#include <iostream>
#include <iomanip>
#include <malloc.h>

#define te point[j][i+1].tem
#define tw point[j][i-1].tem
#define tn point[j+1][i].tem
#define ts point[j-1][i].tem

struct node
{
	int flag;
	double x, y, z, tem;
};

node **mesh(float deltaX, float deltaY, int numPointX, int numPointY); /// 划分网格
void init(node **point, int numPointX, int numPointY, float *TInit); /// 初始化
void iter(node **point, int numPointX, int numPointY,
	  int numIter, float deltaX, float deltaY); /// 计算

int main()
{
	using namespace std;

	int i, j, numCellX, numCellY, numPointX, numPointY, numIter;
	float LX, LY, deltaX, deltaY;
	node **point;
	float T[4] = {100, 200, 300, 400};

	LX = 2;
	LY = 1;
	numCellX = 20;
	numCellY = 10;
	numIter = 3;

	//cout << "input length:";
	//cin >> LX;
	//cout << "input the number of cell:";
	//cin >> numCell;
	//cout << "input the number of iteration:";
	//cin >> numIter;

	deltaX = LX / numCellX;
	deltaY = LY / numCellY;
	numPointX = numCellX + 2;
	numPointY = numCellY + 2;

	point = mesh(deltaX, deltaY, numPointX, numPointY);
	init(point, numPointX, numPointY, T);
	iter(point, numPointX, numPointY, numIter, deltaX, deltaY);

//	printf("node name:\n");
//	for (j = numPointY - 1; j > -1; j--) {
//		for (i = 0; i < numPointX; i++)
//			cout << "(" << j << "," << i << ")";
//		cout << endl;
//	}
//
//	printf("\nnode x:\n");
//	for (j = numPointY - 1; j > -1; j--) {
//		for (i = 0; i < numPointX; i++)
//			cout << setprecision(2) << setiosflags(ios::fixed)
//			     << point[j][i].x << "|";
//		cout << endl
//			}
//	printf("\nnode y:\n");
//	for (j = numPointY - 1; j > -1; j--) {
//		for (i = 0; i < numPointX; i++)
//			cout << setprecision(2) << setiosflags(ios::fixed)
//			     << point[j][i].y << "|";
//		cout << endl;
//	}

	printf("\nnode type:\n");
	for (j = numPointY - 1; j > -1; j--) {
		for (i = 0; i < numPointX; i++)
			cout << point[j][i].flag;
		cout << endl;
	}
	printf("\nnode tem:\n");
	for (j = numPointY - 1; j > -1; j--) {
		for (i = 0; i < numPointX; i++)
			cout << setprecision(0) << setiosflags(ios::fixed)
			     << setw(3) << point[j][i].tem << "|";
		cout << endl;
	}

	free(point);

	return 0;
}

void iter(node **point, int numPointX, int numPointY,
	  int numIter, float deltaX, float deltaY)
{
	int i, j, iter;
	for (iter = 0; iter < numIter; iter++)
		for (j = 1; j < numPointY - 1; j++)
			for (i = 1; i < numPointX - 1; i++) {
				if (point[j][i].flag == 0)
					point[j][i].tem = (te + tw + tn + ts) / 4;
				else if (point[j][i].flag == 1)
					point[j][i].tem = (2 * te + tw + tn + ts) / 5;
				else if (point[j][i].flag == 2)
					point[j][i].tem = (te + tw + 2 * tn + ts) / 5;
				else if (point[j][i].flag == 3)
					point[j][i].tem = (te + 2 * tw + tn + ts) / 5;
				else if (point[j][i].flag == 4)
					point[j][i].tem = (te + tw + tn + 2 * ts) / 5;
				else if (point[j][i].flag == 5)
					point[j][i].tem = (2 * te + tw + 2 * tn + ts) / 6;
				else if (point[j][i].flag == 6)
					point[j][i].tem = (te + 2 * tw + 2 * tn + ts) / 6;
				else if (point[j][i].flag == 7)
					point[j][i].tem = (te + 2 * tw + tn + 2 * ts) / 6;
				else if (point[j][i].flag == 8)
					point[j][i].tem = (2 * te + tw + tn + 2 * ts) / 6;
			}
}

void init(node **point, int numPointX, int numPointY, float *TInit)
{
	int i, j;

	for (j = 0; j < numPointY; j++)
		for (i = 0; i < numPointX; i++)
			if ((j > 1) & (j < numPointY - 2) & (i > 1) & (i < numPointX - 2)) {
				point[j][i].flag = 0;
				point[j][i].tem = 0;
			} else if ((i == numPointX - 2) & (j > 1) & (j < numPointY - 2)) {
				point[j][i].flag = 1;
				point[j][i].tem = 0;
			} else if ((j == numPointY - 2) & (i > 1) & (i < numPointX - 2)) {
				point[j][i].flag = 2;
				point[j][i].tem = 0;
			} else if ((i == 1) & (j > 1) & (j < numPointY - 2)) {
				point[j][i].flag = 3;
				point[j][i].tem = 0;
			} else if ((j == 1) & (i > 1) & (i < numPointX - 2)) {
				point[j][i].flag = 4;
				point[j][i].tem = 0;
			} else if ((j == numPointY - 2) & (i == numPointX - 2)) {
				point[j][i].flag = 5;
				point[j][i].tem = 0;
			} else if ((i == 1) & (j == numPointY - 2)) {
				point[j][i].flag = 6;
				point[j][i].tem = 0;
			} else if ((j == 1) & (i == 1)) {
				point[j][i].flag = 7;
				point[j][i].tem = 0;
			} else if ((j == 1) & (i == numPointX - 2)) {
				point[j][i].flag = 8;
				point[j][i].tem = 0;
			} else if ((i == numPointX - 1) & (j > 0) & (j < numPointY - 1)) {
				point[j][i].flag = 9;
				point[j][i].tem = TInit[0];
			} else if ((i == 0) & (j > 0) & (j < numPointY - 1)) {
				point[j][i].flag = 9;
				point[j][i].tem = TInit[2];
			} else if ((j == numPointY - 1) & (i > 0) & (i < numPointX - 1)) {
				point[j][i].flag = 9;
				point[j][i].tem = TInit[1];
			} else if ((j == 0) & (i > 0) & (i < numPointX - 1)) {
				point[j][i].flag = 9;
				point[j][i].tem = TInit[3];
			}
}

node **mesh(float deltaX, float deltaY, int numPointX, int numPointY)
{
	int i, j;
	node **point;
	point = (node **)malloc( numPointY*sizeof(node *));

	for (j = 0; j < numPointY; j++)
		point[j] = (node *)malloc( numPointX*sizeof(node));

	for (j = 0; j < numPointY; j++)
		for (i = 0; i < numPointX; i++) {
			if (j == 0)
				point[j][i].y = 0;
			else if (j == 1)
				point[j][i].y = deltaY/2;
			else if (j == numPointY - 1)
				point[j][i].y = point[j-1][i].y + deltaY/2;
			else
				point[j][i].y = point[j-1][i].y + deltaY;
			if (i == 0)
				point[j][i].x = 0;
			else if (i == 1)
				point[j][i].x = deltaX/2;
			else if (i == numPointX - 1)
				point[j][i].x = point[j][i-1].x + deltaX/2;
			else
				point[j][i].x = point[j][i-1].x + deltaX;
		}

	return point;
}
